//
//  ProductListPageViewController.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/21/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit
import RxSwift
import RxCocoa
import RxDataSources

protocol ProductListPagePresenterInterface: PresenterInterface {
    
}

final class ProductListPageViewController: UIViewController, ProductListPageViewInterface {
    
    // MARK: - Public properties
    
    let viewModels = BehaviorRelay<[ProductItemViewModel]>(value: [])
    
    // MARK: - Public properties -
    @IBOutlet weak private var tableView: UITableView!
    
    private lazy var dataSource = makeDataSource()
    
    private let disposeBag = DisposeBag()
    private let viewDidLoadRelay = BehaviorRelay(value: false)
    
    var presenter: ProductListPagePresenterInterface!
    
    // MARK: - Lifecycle -
    
    override func viewDidLoad() {
        super.viewDidLoad()
        defer {
            viewDidLoadRelay.accept(true)
        }
        configureViews()
        configurePresenter()
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
    }
    
    override func viewWillDisappear(_ animated: Bool) {
        super.viewWillDisappear(animated)
    }
}
// MARK: - Extensions -

extension ProductListPageViewController {
    private func configurePresenter() {
        
        let didLoad = viewDidLoadRelay.asObservable()
        viewModels
            .filterEmpty()
            .map { [ Section(model: 0, items: $0)]}
            .takeLatestWhen(didLoad)
            .asDriver(onErrorDriveWith: .never())
            .drive(tableView.rx.items(dataSource: dataSource))
            .disposed(by: disposeBag)
    }
}

extension ProductListPageViewController {
    
    private func configureViews(){
        configureTableViews()
    }
    
    private func configureTableViews() {
        
        tableView.contentInset = UIEdgeInsets(top: UIConfig.tableViewTopBottomPadding, left: .zero, bottom: UIConfig.tableViewTopBottomPadding, right: .zero)
        tableView.register(cellType: ProductItemCell.self)
    }
    
    enum UIConfig {
        static let tableViewTopBottomPadding: CGFloat = 16
    }
}

extension ProductListPageViewController {
    typealias Section = AnimatableSectionModel<Int, ProductItemViewModel>
    typealias DataSource = RxTableViewSectionedAnimatedDataSource<Section>
}

extension ProductListPageViewController {
    private func makeDataSource() -> DataSource {
        let animation = AnimationConfiguration(
            insertAnimation: .automatic,
            reloadAnimation: .automatic,
            deleteAnimation: .automatic
        )
        
        return DataSource(
            animationConfiguration: animation,
            configureCell: {(_, tableView, indexPath, model) -> UITableViewCell in
                let cell: ProductItemCell = tableView.dequeueReusableCell(for: indexPath)
                cell.configureCell(viewModel: model)
                return cell
            })
    }
}

